library ArcNeuralNetwork.LearningRule.Adaline;

import '../Functions/activationfunction.dart';
import '../Functions/inputfunction.dart';
import "../neuron.dart";
import "../layer.dart";
import "../network.dart";
import "learningrule.dart";

class Adaline extends LearningRule {

  Adaline() {
  }

  createNetwork(int numberInput) {

    this.neuralNetwork = new Network();

    List<Neuron> inputNeurons = [];
    List<Neuron> adalineNeuron = [];

    for (var i = 0; i < numberInput; i++) {
      inputNeurons.add(new Neuron("Input" + i));
    }

    Neuron adaline = new Neuron.Functions("Adaline", new WeightCombination(), new Linear());

    for (var i = 0; i < inputNeurons; i++) {
      inputNeurons[i].addOutputConnection(new Connection.WeightRandomRange(inputNeurons[i], adaline, 0.0, 1.0));
    }

    adalineNeuron.add(adaline);

    this.neuralNetwork.addLayer(new Layer.Neurons("InputLayer", inputNeurons));
    this.neuralNetwork.addLayer(new Layer.Neurons("AdalineLayer", adalineNeuron));


  }


  Learn(DataSet trainSet) {

  }

  LearnCycle() {

  }

  LearnStep() {

  }

  Test(DataSet testSet) {

  }


}
