library ArcNeuralNetwork.LearningRule;

import '../Functions/activationfunction.dart';
import '../Functions/inputfunction.dart';
import "../neuron.dart";
import "../layer.dart";
import "../network.dart";



abstract class LearningRule {

  Dataset trainSet;
  Dataset testSet;
  Network neuralNetwork;

  LearningRule() {}

  Learn(Dataset trainSet);

  LearnCycle();

  LearnStep();

  Test(Dataset testSet);



}
